function f = matrix2poly(matrix,d)
% f = matrix2poly(matrix,d)
% rewrite a filter in matrix form to polynomial form
% input:      d -- a two-element vector consists of the lowest degree of z0 and z1
%        matrix -- the filter coefficients in matrix form:
%                  1, z1, z1^2, . . .
%                1
%               z0
%             z0^2
%               .
%               .
%               .
% output:     f -- filter in polynomial form            
% Copyright (c) 2006 Yi Chen

syms z0 z1
sizem = size(matrix);

f = sym('0');

for i = 1:sizem(1)
    for j = 1:sizem(2)
        f = f + matrix(i,j)*z1^(j-1+d(2))*z0^(i-1+d(1));
    end
end
